--This Lua file spawns all A2G units dynamically use exact names in ME to have script work. 
--The dashes are for formatting, dont add them into any part of the operating script!


--Creating spawn zones
EZ_Zone = {
ZONE:New("A2GEasy-1"),
ZONE:New("A2GEasy-2"),
ZONE:New("A2GEasy-3"),
ZONE:New("A2GEasy-4"),
ZONE:New("A2GEasy-5"),
ZONE:New("A2GEasy-6"),
 }
 
Boats_Zone = ZONE:New("Boat Zone") 
 
Med_Zone = {
ZONE:New("A2GMed-1"),
ZONE:New("A2GMed-2"),
ZONE:New("A2GMed-3"),
ZONE:New("A2GMed-4"),
ZONE:New("A2GMed-5"),
ZONE:New("A2GMed-6"),
}

Hard_Zone = {
ZONE:New("A2GHard-1"),
ZONE:New("A2GHard-2"),
ZONE:New("A2GHard-3"),
ZONE:New("A2GHard-4"),
ZONE:New("A2GHard-5"),
ZONE:New("A2GHard-6"),
ZONE:New("A2GHard-7"),
}

DS_Zone = {
ZONE:New("Deep Strike-1"),
ZONE:New("Deep Strike-2"),
ZONE:New("Deep Strike-3"),
}

Infantry_Zone = {
ZONE:New("Infantry Assault-1"),
ZONE:New("Infantry Assault-2"),
ZONE:New("Infantry Assault-3"),
ZONE:New("Infantry Assault-4"),
ZONE:New("Infantry Assault-5"),
}

SCUD_Zone = {
ZONE:New("SCUD Spawn Zone-1"),
ZONE:New("SCUD Spawn Zone-2"),
ZONE:New("SCUD Spawn Zone-3"),
ZONE:New("SCUD Spawn Zone-4"),
ZONE:New("SCUD Spawn Zone-5"),
}

--**A2G Templates. These templates detemine how many and which types units will spawn.**
--Create a group in mission editor with the names listed in the templates below without "" and set late activation on all groups.

--A2G Easy Unit templates
 TemplateTable_A2GEz = {
 "EasyTemplate-1",
 "EasyTemplate-2",
 "EasyTemplate-3",
 "EasyTemplate-4",
}

--A2G Medium Unit templates
TemplateTable_A2GMed = {
 "MedTemplate-1",
 "MedTemplate-2",
 "MedTemplate-3",
 "MedTemplate-4"
}

--A2G Hard Unit templates
TemplateTable_A2GHard = {
 "HardTemplate-1",
 "HardTemplate-2",
 "HardTemplate-3",
}

--Deepstrike Templates
TemplateTable_DS = {
 "DSTemplate-1",
 "DSTemplate-2",
}

--Infantry Assault Templates
TemplateTable_InfAssault = {
 "InfantryTemplate-1",
 "InfantryTemplate-2",
}
--Boat templates
Template_Table_Boats = {
"Boats-1",
"Boats-2",
}

-------------------------------------------------------------------------------------------------end of templates

--**Place "Ground Easy#" units in mission editor without quotes. Only one unit needs to be placed in center of target area also set late activation on all groups.

--Red Boats spawns

Boats = SPAWN:New("Red Boats")
:InitRandomizeTemplate( Template_Table_Boats )    
:InitHeading (001, 359)
:InitLimit(9, 3)



--A2G Easy Spawns	

A2G_Easy = SPAWN:New( "EasyPlaceholder" )
:InitRandomizeTemplate( TemplateTable_A2GEz )  
:InitRandomizeUnits (true, 1000, 20)  
:InitHeading (001, 359)
:InitRandomizeZones(EZ_Zone)


--calls up random units from the template above
--places units in a random area in a circle of min (Must be true, The outer radius in meters where the new group will be spawned, The inner radius in meters where the new group will NOT be spawned)
--randomized unit heading between 001 to 359

--A2G Easy Activation scripts(add to mission editor triggers into do script)
--A2G_Easy:Spawn()


--A2G Medium Spawns
A2G_Med = SPAWN:New( "MedPlaceholder" )
:InitRandomizeTemplate( TemplateTable_A2GMed )
:InitRandomizeUnits (true, 1500, 50)
:InitHeading (001, 359)
:InitRandomizeZones(Med_Zone)

--A2G Medium Activation scripts(add to mission editor triggers into do script)
--A2G_Med1:Spawn()

--A2G Hard Spawns
A2G_Hard = SPAWN:New( "HardPlaceholder" )
:InitRandomizeTemplate( TemplateTable_A2GHard )
:InitRandomizeUnits (true, 1500, 50)
:InitHeading (001, 359)
:InitRandomizeZones(Hard_Zone)

--A2G Hard Activation scripts(add to mission editor triggers into do script)
--A2G_Hard:Spawn()

A2G_DS = SPAWN:New( "DSPlaceholder" )
:InitRandomizeTemplate( TemplateTable_DS )
:InitRandomizeUnits (true, 1500, 50)
:InitHeading (001, 359)
:InitRandomizeZones(DS_Zone)

--A2G Deep Strike Activation scripts(add to mission editor triggers into do script)
--A2G_DS:Spawn()


--Infantry Assault spawns
InfantryAss = SPAWN:New( "InfantryPlaceholder" )
:InitRandomizeTemplate( TemplateTable_InfAssault )
:InitRandomizeUnits (true, 150, 10)
:InitHeading (001, 359)
:InitRandomizeZones(Infantry_Zone)

--SCUD Spawner
SCUD = SPAWN:New( "SCUD Convoy" )
:InitRandomizeZones(SCUD_Zone)

--Infantry Activation scripts(add to mission editor triggers into do script)
--InfantryAss:Spawn()

--Autolase JTAC
JTACAutoLase("EasyDrone", 1686, true,"all", 1)
JTACAutoLase("MedDrone", 1686, true,"all", 1)
JTACAutoLase("HardDrone", 1686, true,"all", 1)
JTACAutoLase("DSDrone", 1686, true,"all", 1)

-----------------------------------------------------------------------------------------------------------End Of spawning groups

